<div class="page-wrapper">
    <div class="page page-profile _narrow-container">
        <zeb-page-header
            page-title="$ctrl.currentTitle">
        </zeb-page-header>
        <div class="page-profile__body">
            <div class="profile-header">
                <div layout="row" flex="auto">
                    <div class="profile-img">
                        <profile-photo ng-model="$ctrl.currentUser.photoUrl" size="48">
                            <div class="profile-img-content">
                                <i class="material-icons" ng-click="$ctrl.showUploadImageDialog($event)">add_a_photo</i>
                            </div>
                        </profile-photo>
                    </div>
                    <div class="profile-wrapper" layout-gt-xs="row" flex="100" layout-align="end start">
                        <div class="profile-personal-content">
                            <div class="profile-personal-info" ng-if="$ctrl.currentUser.firstName || $ctrl.currentUser.lastName">
                                <div class="profile-personal-name">{{$ctrl.currentUser.firstName}}</div>
                                <div class="profile-personal-name">{{$ctrl.currentUser.lastName}}</div>
                            </div>
                            <md-input-container flex class="no-margin">
                                <div id="userRole" class="label label-default" data-ng-repeat="role in $ctrl.user.roles" style="margin-right: 5px;">{{role}}</div>
                            </md-input-container>
                        </div>
                        <div class="profile-versions-info"
                            flex="none"
                            layout="column"
                            layout-align="start end"
                            layout-align-xs="start start"
                            ng-if="$ctrl.appVersions.ui || $ctrl.appVersions.service || $ctrl.appVersions.client">
                            <span class="md-caption no-margin" ng-if="$ctrl.appVersions.ui">ui: {{$ctrl.appVersions.ui}}</span>
                            <span class="md-caption no-margin" ng-if="$ctrl.appVersions.service">server: {{$ctrl.appVersions.service}}</span>
                        </div>
                    </div>
                </div>
            </div>
            <div layout="column" class="profile__form-wrapper">
                <div class="profile__form-title">Zebrunner API access</div>
                <form class="form-validation profile__form" name="access_token_form" ng-submit="$ctrl.generateAccessToken()">
                    <div class="profile__form-row _access" layout="row" layout-align="center center">
                        <md-input-container class="_gray-bg">
                            <input id="serviceUrl" type="text" ng-model="$ctrl.serviceUrl" name="serviceUrl" disabled/>
                            <label>Service URL</label>
                        </md-input-container>
                        <md-button data-ng-click="$ctrl.copyServiceUrl()" ng-disabled="!$ctrl.serviceUrl" class="md-icon-button _invert pull-right"><md-icon class="material-icons" role="img" aria-label="autorenew">file_copy</md-icon></md-button>
                    </div>
                    <div class="profile__form-row _access" layout="row" layout-align="center center">
                        <md-input-container class="_gray-bg">
                            <label>Token</label>
                            <input id="userAccessToken" type="text" ng-model="$ctrl.accessToken" name="accessToken"/>
                        </md-input-container>
                        <md-button id="generateToken" ng-if="!$ctrl.accessToken" type="submit" class="md-icon-button _invert pull-right gtm-generate-token-button"><md-icon class="material-icons _renew" role="img" aria-label="autorenew">autorenew</md-icon></md-button>
                        <md-button id="copyToken" ng-if="$ctrl.accessToken" ng-click="$ctrl.copyAccessToken()" class="md-icon-button _invert pull-right"><md-icon class="material-icons" role="img" aria-label="autorenew">file_copy</md-icon></md-button>
                    </div>
                </form>
            </div>
            <div layout="column" class="profile__form-wrapper">
                <div class="profile__form-title">Personal data</div>
                <form name="profile_form" class="profile__form" ng-submit="$ctrl.updateUserProfile()">
                    <div class="profile__form-row" layout="row">
                        <md-input-container flex class="_gray-bg">
                            <label>Username</label>
                            <input id="userUsername" type="text" ng-model="$ctrl.user.username" name="username" disabled/>
                        </md-input-container>
                        <md-input-container flex class="_gray-bg">
                            <label>Email</label>
                            <input id="userEmail" type="email" ng-model="$ctrl.user.email" name="email" ng-pattern="/^.+@.+\..+$/" disabled>
                            <div ng-messages="profile_form.email.$error" ng-if="profile_form.email.$dirty">
                                <div ng-message="required">Required</div>
                                <div ng-message="pattern">Invalid format</div>
                            </div>
                        </md-input-container>
                    </div>
                    <div class="profile__form-row" layout="row">
                        <md-input-container flex class="_gray-bg">
                            <label>First Name</label>
                            <input id="userFirstName"
                                type="text"
                                ng-model="$ctrl.user.firstName"
                                name="firstName"
                                ng-minlength="::$ctrl.getValidationValue('name', 'minlength')"
                                ng-maxlength="::$ctrl.getValidationValue('name', 'maxlength')"
                                ng-pattern="::$ctrl.getValidationValue('name', 'pattern')"
                                required
                            />
                            <div ng-messages="profile_form.firstName.$error">
                                <div ng-repeat="validation in $ctrl.validations.name" ng-message="{{ validation.name }}">
                                <span ng-if="validation.additional">
                                    <md-tooltip md-direction="top">{{ validation.additional }}</md-tooltip>
                                    {{ validation.message }}
                                </span>
                                    <span ng-if="! validation.additional">{{ validation.message }}</span>
                                </div>
                            </div>
                        </md-input-container>
                        <md-input-container flex class="_gray-bg">
                            <label>Last Name</label>
                            <input id="userLastName"
                                type="text"
                                ng-model="$ctrl.user.lastName"
                                name="lastName"
                                ng-minlength="::$ctrl.getValidationValue('name', 'minlength')"
                                ng-maxlength="::$ctrl.getValidationValue('name', 'maxlength')"
                                ng-pattern="::$ctrl.getValidationValue('name', 'pattern')"
                                required
                            />
                            <div ng-messages="profile_form.lastName.$error">
                                <div ng-repeat="validation in $ctrl.validations.name" ng-message="{{ validation.name }}">
                                    <span ng-if="validation.additional">
                                        <md-tooltip md-direction="top">{{ validation.additional }}</md-tooltip>
                                        {{ validation.message }}
                                    </span>
                                    <span ng-if="! validation.additional">{{ validation.message }}</span>
                                </div>
                            </div>
                        </md-input-container>
                    </div>
                    <md-button id="saveUserInfo" type="submit"
                        class="md-raised btn-w-md md-primary pull-right"
                        ng-disabled="profile_form.$invalid">Save</md-button>
                </form>
            </div>
            <div ng-if="$ctrl.user.source === 'INTERNAL'" layout="column" class="profile__form-wrapper">
                <div class="profile__form-title">Change password</div>
                <form class="form-validation profile__form" name="password_form" ng-submit="$ctrl.updateUserPassword(); $ctrl.untouchForm(password_form);">
                    <div class="profile__form-row">
                        <md-input-container class="_gray-bg _password">
                            <label>Old password</label>
                            <input id="userOldPassword" type="password" ng-model="$ctrl.changePassword.oldPassword" name="password" required/>
                        </md-input-container>
                    </div>
                    <div class="profile__form-row">
                        <md-input-container  class="_password _gray-bg">
                            <label>Password</label>
                            <input id="userPassword"
                                password-eye="mousedown - mouseup"
                                type="password"
                                ng-model="$ctrl.changePassword.newPassword"
                                name="password"
                                ng-minlength="::$ctrl.getValidationValue('password', 'minlength')"
                                ng-maxlength="::$ctrl.getValidationValue('password', 'maxlength')"
                                ng-pattern="::$ctrl.getValidationValue('password', 'pattern')"
                                required
                            />
                            <div ng-messages="password_form.password.$error" ng-if="password_form.password.$dirty">
                                <div ng-repeat="validation in ::$ctrl.validations.password" ng-message="{{validation.name}}">
                                    <span ng-if="validation.additional">
                                        <md-tooltip md-direction="top">{{ validation.additional }}</md-tooltip>
                                        {{ validation.message }}
                                    </span>
                                    <span ng-if="! validation.additional">{{ validation.message }}</span>
                                </div>
                            </div>
                        </md-input-container>
                    </div>
                    <md-button id="changePassword" type="submit"
                        class="md-raised btn-w-md md-primary pull-right"
                        ng-disabled="password_form.$invalid">Change</md-button>
                </form>
            </div>
        </div>
    </div>
</div>
